Module:    wt-example1
Synopsis:  Example of using the Wild Tangent control
Author:    Chris Double
Copyright: (C) 2000, Chris Double.  All rights reserved.

// I should really put this in a com utilities library.
define macro let-com-interface
  { let-com-interface ?:name :: ?type:expression = ?value:expression;
    ?:body }
  => { let ?name :: ?type = ?value;
       block()         
         ?body
       cleanup
         release(?name)
       end }
end macro let-com-interface;

define frame <wt-example1-frame> (<simple-frame>)
  pane wild-tangent-pane (frame)
    make(<wild-tangent-gadget>, min-width: 640, min-height: 480);

  pane go-button (frame)
    make(<push-button>, label: "Go", activate-callback: on-go-button);

  pane stop-button (frame)
    make(<push-button>, label: "Stop", activate-callback: on-stop-button);

  layout (frame)
    vertically()
      horizontally()
        frame.go-button;
        frame.stop-button;
      end;
      frame.wild-tangent-pane;
    end;

  keyword title: = "WildTangent Example 1";
end frame <wt-example1-frame>;

define method on-go-button(g)
  let frame = g.sheet-frame;
  let wt-gadget = frame.wild-tangent-pane;
  let-com-interface control :: <IWT> = wt-gadget.wild-tangent-interface;
  let-com-interface stage :: <IWTStage> = IWT/createStageFromFile(control, "..\\pool.wpk");
  IWT/start(control);
end method on-go-button;

define method on-stop-button(g)
  let frame = g.sheet-frame;
  let wt-gadget = frame.wild-tangent-pane;
  let-com-interface control :: <IWT> = wt-gadget.wild-tangent-interface;
  IWT/stop(control);
end method on-stop-button;

define method main () => ()
  unless(wild-tangent-initialize())
    notify-user("Failed to load Wild Tangent Gadget libary. Check ATL.DLL version.");
  end;
  start-frame(make(<wt-example1-frame>));
  wild-tangent-uninitialize();
end method main;

begin
  main();
end;

